#ifdef __GNUG__
#pragma implementation "listx_tmpl.hxx"
#pragma implementation "dictx_tmpl.hxx"
#pragma implementation "sharedcol_tmpl.hxx"
#pragma implementation "smartp_tmpl.hxx"
#pragma implementation "c++_const.hxx"
#pragma implementation "dictionary_tmpl.hxx"
#pragma implementation "dbvue_clnt.hxx"
#pragma implementation "callbackclient_clnt.hxx"
#pragma implementation "callbackserver_clnt.hxx"
#pragma implementation "iter_tmpl.hxx"
#endif

#include "yoo_root.hxx"
#include "dictionary.hxx"
#define __YOODA_MAIN

#include "listln.hxx"
#include "dict.hxx"
#include "test.hxx"

template class Iterator<ADM_SchFile> ;
template class Iterator<ObjectX> ;
template class Iterator<ADM_Clu> ;
template class Iterator<ADM_Vol> ;
template class Iterator<ADM_Class> ;
template class Iterator<ADM_NameObj> ;
template class Iterator<ADM_Server> ;
template class Iterator<ADM_Col> ;

template class LocalListX<ADM_SchFile> ;
template class LocalListX<ObjectX> ;
template class LocalListX<ADM_Clu> ;
template class LocalListX<ADM_Vol> ;
template class LocalListX<ADM_Class> ;
template class LocalListX<ADM_NameObj> ;
template class LocalListX<ADM_Server> ;
template class LocalListX<ADM_Col> ;

template class ListX<ADM_SchFile> ;
template class ListX<ObjectX> ;
template class ListX<ADM_Clu> ;
template class ListX<ADM_Vol> ;
template class ListX<ADM_Class> ;
template class ListX<ADM_NameObj> ;
template class ListX<ADM_Server> ;
template class ListX<int> ;
template class ListX<double> ;
template class ListX<StringX> ;

template class DictX<ADM_Vol, StringX, yoo_index(ADM_Vol::name)> ;
template class DictX<ADM_Clu, StringX, yoo_index(ADM_Clu::name)> ;
template class DictX<ADM_Class, StringX, yoo_index(ADM_Class::name)> ;
template class DictX<ADM_NameObj, StringX, yoo_index(ADM_NameObj::name)> ;
template class DictX<ADM_SchFile, StringX, yoo_index(ADM_SchFile::name)> ;
template class DictX<ADM_Server, StringX, yoo_index(ADM_Server::name)> ;


Ref<ADM_Admin> YoodaDictionary ;

extern void (*YOO_TabRefresh[]) (void *) ;
void yoo_refreshInit() {
  //0 reserved for non C++ objects
  YOO_TabRefresh[3] = ListNode::yoo_refresh ;
  YOO_TabRefresh[4] = ListLeaf::yoo_refresh ;
  YOO_TabRefresh[5] = DictNode::yoo_refresh ;
  YOO_TabRefresh[6] = DictLeaf::yoo_refresh ;

  YoodaDictionary.setOid(OID(YOO_ADMIN_VOL, YOO_FIRST_USED_PAGE, 3)) ;
  YOO_DEF_CLU = YoodaDictionary->defClu->clu ; 



  ADM_Class* cl ;
  cl = YoodaDictionary->dictClass.getFirst("MainObj");
  MainObj::yoo_ClId = cl->clId ;
  if (cl == NULL) { 
    cerr << "MainObj" << " : unknown class" << endl;
  }
  MainObj::yoo_Cluster=cl->myClu->clu;
  YOO_TabRefresh[cl->clId] = MainObj::yoo_refresh ;

  cl = YoodaDictionary->dictClass.getFirst("TstObj");
  TstObj::yoo_ClId = cl->clId ;
  if (cl == NULL) { 
    cerr << "TstObj" << " : unknown class" << endl;
  }
  TstObj::yoo_Cluster=cl->myClu->clu;
  YOO_TabRefresh[cl->clId] = TstObj::yoo_refresh ;

  cl = YoodaDictionary->dictClass.getFirst("TstObjRoot");
  TstObjRoot::yoo_ClId = cl->clId ;
  if (cl == NULL) { 
    cerr << "TstObjRoot" << " : unknown class" << endl;
  }
  TstObjRoot::yoo_Cluster=cl->myClu->clu;
  YOO_TabRefresh[cl->clId] = TstObjRoot::yoo_refresh ;

}

Ref<Cluster> MainObj::yoo_Cluster ;
int MainObj::yoo_ClId ;
template class Ref<MainObj> ;
Ref<Cluster> TstObj::yoo_Cluster ;
int TstObj::yoo_ClId ;
template class Ref<TstObj> ;
Ref<Cluster> TstObjRoot::yoo_Cluster ;
int TstObjRoot::yoo_ClId ;
template class Ref<TstObjRoot> ;


#include "test_tmpl.hxx"

void (*YOO_TabRefresh[10]) (void*) ;
int YOO_LastClassId = 9;
